program pufftest;
{$APPTYPE CONSOLE}
uses libunpak;

var
  x, y, sz: longword;
      p, u: pbyte;
        fl: file;
begin
  if (paramcount <> 1) then
  begin
    writeln('usage: <filename.dat>');
    exit;
  end;
  assignfile(fl, paramstr(1));
  reset(fl, 1);
  sz:=filesize(fl);
  getmem(p, sz);
  blockread(fl, p^, sz);
  closefile(fl);

  x:=0;
  y:=sz;
  if (undeflate(nil, @x, p, @y) >= 0) then
  begin
    getmem(u, x);
    y:=sz;
    undeflate(u, @x, p, @y);
    assignfile(fl, 'undeflate-' + paramstr(1));
    rewrite(fl, 1);
    blockwrite(fl, u^, x);
    closefile(fl);
    freemem(u, x);
  end;

  x:=0;
  y:=sz;
  if (unpkware(nil, @x, p, @y) >= 0) then
  begin
    getmem(u, x);
    y:=sz;
    unpkware(u, @x, p, @y);
    assignfile(fl, 'unpkware-' + paramstr(1));
    rewrite(fl, 1);
    blockwrite(fl, u^, x);
    closefile(fl);
    freemem(u, x);
  end;

  freemem(p, sz);
end.
